#include<stdio.h>

#include<cv.h>
#include<cxcore.h>
#include<highgui.h>

int main(int argc, char **argv) {
    
    printf("hello opencv!\n");
    
    IplImage *first;
    first = cvLoadImage("mondrian.jpg", CV_LOAD_IMAGE_GRAYSCALE);
    if (first == 0) {
        fprintf(stderr, "Error: cannot load first image\n");
        return -1;
    }
    
    cvNamedWindow("First");
    cvShowImage("First", first);
    cvWaitKey(0);
    
    IplImage *second;
    second = cvCreateImage(cvSize(first->width, first->height), IPL_DEPTH_16S, first->nChannels);
    if (second == 0) {
        fprintf(stderr, "Error: can't create second image\n");
        return -1;
    }
    
    cvSobel(first, second, 1, 0, 7);
        
    cvNamedWindow("Second");
    cvShowImage("Second", second);
    cvWaitKey(0);

    IplImage *fourth;
    fourth = cvCreateImage(cvSize(first->width, first->height), IPL_DEPTH_8U, first->nChannels);
    if (fourth == 0) {
        fprintf(stderr, "Error: can't create third image\n");
        return -1;
    }
    
    cvSmooth(first, fourth, CV_GAUSSIAN, 11, 1);
    cvShowImage("Second", fourth);
    cvWaitKey(0);

    IplImage *third;
    third = cvCreateImage(cvSize(first->width, first->height), IPL_DEPTH_16S, first->nChannels);
    if (third == 0) {
        fprintf(stderr, "Error: can't create third image\n");
        return -1;
    }

    cvSobel(fourth, third, 1, 0, 7);
    cvShowImage("Second", third);
    cvWaitKey(0);
    
    cvReleaseImage(&first);
    cvDestroyWindow("First");
    cvReleaseImage(&second);
    cvDestroyWindow("Second");
    cvReleaseImage(&third);
    cvReleaseImage(&fourth);
    return 0;
}
